import {
  slash
} from "../chunk-5TNYWP3O.js";
import {
  distDir
} from "../chunk-XUIDSY4V.js";
import {
  nanoid
} from "../chunk-APGELTDH.js";
import {
  init_esm_shims
} from "../chunk-R2SMNEBL.js";

// src/runtime/worker.ts
init_esm_shims();
import { resolve as resolve2 } from "path";

// src/node/execute.ts
init_esm_shims();
import { builtinModules, createRequire } from "module";
import { fileURLToPath, pathToFileURL } from "url";
import { dirname, resolve } from "path";
import vm from "vm";
var defaultInline = [
  "vitest/dist/runtime/entry.js",
  "vitest/src/runtime/entry.ts",
  "@vue",
  "@vueuse",
  "vue-demi",
  "vue",
  /virtual:/,
  /\.ts$/,
  /\/esm\/.*\.js$/,
  /\.(es|esm|esm-browser|esm-bundler|es6).js$/
];
var depsExternal = [
  /\.cjs.js$/
];
var isWindows = process.platform === "win32";
var stubRequests = {
  "/@vite/client": {
    injectQuery: (id) => id,
    createHotContext() {
      return {
        accept: () => {
        },
        prune: () => {
        }
      };
    },
    updateStyle() {
    }
  }
};
async function interpretedImport(path, interpretDefault) {
  const mod = await import(path);
  if (interpretDefault && "__esModule" in mod && "default" in mod) {
    const defaultExport = mod.default;
    if (!("default" in defaultExport)) {
      Object.defineProperty(defaultExport, "default", {
        enumerable: true,
        configurable: true,
        get() {
          return defaultExport;
        }
      });
    }
    return defaultExport;
  }
  return mod;
}
async function executeInViteNode(options) {
  const { moduleCache: moduleCache2, root, files, fetch } = options;
  const externaled = new Set(builtinModules);
  const result = [];
  for (const file of files)
    result.push(await cachedRequest(`/@fs/${slash(resolve(file))}`, []));
  return result;
  async function directRequest(id, fsPath, callstack) {
    callstack = [...callstack, id];
    const request = async (dep) => {
      var _a;
      if (callstack.includes(dep)) {
        const cacheKey = toFilePath(dep, root);
        if (!((_a = moduleCache2.get(cacheKey)) == null ? void 0 : _a.exports))
          throw new Error(`Circular dependency detected
Stack:
${[...callstack, dep].reverse().map((p) => `- ${p}`).join("\n")}`);
        return moduleCache2.get(cacheKey).exports;
      }
      return cachedRequest(dep, callstack);
    };
    if (id in stubRequests)
      return stubRequests[id];
    const result2 = await fetch(id);
    if (!result2)
      throw new Error(`failed to load ${id}`);
    const url = pathToFileURL(fsPath).href;
    const exports = {};
    setCache(fsPath, { transformResult: result2, exports });
    const __filename2 = fileURLToPath(url);
    const context = {
      require: createRequire(url),
      __filename: __filename2,
      __dirname: dirname(__filename2),
      __vite_ssr_import__: request,
      __vite_ssr_dynamic_import__: request,
      __vite_ssr_exports__: exports,
      __vite_ssr_exportAll__: (obj) => exportAll(exports, obj),
      __vite_ssr_import_meta__: { url }
    };
    const fn = vm.runInThisContext(`async (${Object.keys(context).join(",")})=>{${result2.code}
}`, {
      filename: fsPath,
      lineOffset: 0
    });
    await fn(...Object.values(context));
    return exports;
  }
  function setCache(id, mod) {
    if (!moduleCache2.has(id))
      moduleCache2.set(id, mod);
    else
      Object.assign(moduleCache2.get(id), mod);
  }
  async function cachedRequest(rawId, callstack) {
    var _a, _b;
    const id = normalizeId(rawId);
    if (externaled.has(id))
      return interpretedImport(id, options.interpretDefault);
    const fsPath = toFilePath(id, root);
    const importPath = patchWindowsImportPath(fsPath);
    if (externaled.has(importPath) || await shouldExternalize(importPath, options)) {
      externaled.add(importPath);
      return interpretedImport(importPath, options.interpretDefault);
    }
    if ((_a = moduleCache2.get(fsPath)) == null ? void 0 : _a.promise)
      return (_b = moduleCache2.get(fsPath)) == null ? void 0 : _b.promise;
    const promise = directRequest(id, fsPath, callstack);
    setCache(fsPath, { promise });
    return await promise;
  }
  function exportAll(exports, sourceModule) {
    for (const key in sourceModule) {
      if (key !== "default") {
        try {
          Object.defineProperty(exports, key, {
            enumerable: true,
            configurable: true,
            get() {
              return sourceModule[key];
            }
          });
        } catch (_err) {
        }
      }
    }
  }
}
function normalizeId(id) {
  if (id && id.startsWith("/@id/__x00__"))
    id = `\0${id.slice("/@id/__x00__".length)}`;
  if (id && id.startsWith("/@id/"))
    id = id.slice("/@id/".length);
  if (id.startsWith("__vite-browser-external:"))
    id = id.slice("__vite-browser-external:".length);
  if (id.startsWith("node:"))
    id = id.slice("node:".length);
  return id;
}
async function shouldExternalize(id, config) {
  if (matchExternalizePattern(id, config.inline))
    return false;
  if (matchExternalizePattern(id, config.external))
    return true;
  if (matchExternalizePattern(id, depsExternal))
    return true;
  if (matchExternalizePattern(id, defaultInline))
    return false;
  return id.includes("/node_modules/");
}
function toFilePath(id, root) {
  id = slash(id);
  let absolute = id.startsWith("/@fs/") ? id.slice(4) : id.startsWith(dirname(root)) ? id : id.startsWith("/") ? slash(resolve(root, id.slice(1))) : id;
  if (absolute.startsWith("//"))
    absolute = absolute.slice(1);
  return isWindows && absolute.startsWith("/") ? pathToFileURL(absolute.slice(1)).href : absolute;
}
function matchExternalizePattern(id, patterns) {
  for (const ex of patterns) {
    if (typeof ex === "string") {
      if (id.includes(`/node_modules/${ex}/`))
        return true;
    } else {
      if (ex.test(id))
        return true;
    }
  }
  return false;
}
function patchWindowsImportPath(path) {
  if (path.match(/^\w:\//))
    return `/${path}`;
  else
    return path;
}

// src/runtime/worker.ts
var _run;
var moduleCache = /* @__PURE__ */ new Map();
async function init(ctx) {
  if (_run)
    return _run;
  const { config } = ctx;
  _run = (await executeInViteNode({
    root: config.root,
    files: [
      resolve2(distDir, "runtime/entry.js")
    ],
    fetch(id) {
      return process.__vitest_worker__.rpc("fetch", id);
    },
    inline: config.depsInline,
    external: config.depsExternal,
    interpretDefault: config.interpretDefault,
    moduleCache
  }))[0].run;
  return _run;
}
async function run(ctx) {
  process.stdout.write("\0");
  const { config, port } = ctx;
  const rpcPromiseMap = /* @__PURE__ */ new Map();
  process.__vitest_worker__ = {
    config,
    rpc: (method, ...args) => {
      return new Promise((resolve3, reject) => {
        const id = nanoid();
        rpcPromiseMap.set(id, { resolve: resolve3, reject });
        port.postMessage({ method, args, id });
      });
    },
    send(method, ...args) {
      port.postMessage({ method, args });
    }
  };
  port.addListener("message", async (data) => {
    const api = rpcPromiseMap.get(data.id);
    if (api) {
      if (data.error)
        api.reject(data.error);
      else
        api.resolve(data.result);
    }
  });
  const run2 = await init(ctx);
  if (ctx.invalidates)
    ctx.invalidates.forEach((i) => moduleCache.delete(i));
  ctx.files.forEach((i) => moduleCache.delete(i));
  return run2(ctx.files, ctx.config);
}
export {
  run as default,
  init
};
